SizeSelector (Apache Ant API)
Date: 2018-07-10

org.apache.tools.ant.types.selectors

## Class SizeSelector

- java.lang.Object
- - org.apache.tools.ant.ProjectComponent
  - - org.apache.tools.ant.types.DataType
    - - org.apache.tools.ant.types.selectors.BaseSelector
      - - org.apache.tools.ant.types.selectors.BaseExtendSelector
        - - org.apache.tools.ant.types.selectors.SizeSelector

- All Implemented Interfaces:
    java.lang.Cloneable, Parameterizable, ExtendFileSelector, FileSelector

      public class SizeSelector
      extends BaseExtendSelector

  Selector that filters files based on their size.
  Since:
    1.5

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SizeSelector.ByteUnits` Enumerated attribute with the values for units.
    `static class` | `SizeSelector.SizeComparisons` Enumerated attribute with the values for size comparison.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `SIZE_KEY` Used for parameterized custom selector
    `static java.lang.String` | `UNITS_KEY` Used for parameterized custom selector
    `static java.lang.String` | `WHEN_KEY` Used for parameterized custom selector

    - ### Fields inherited from class org.apache.tools.ant.types.selectors.BaseExtendSelector

      `parameters`

    - ### Fields inherited from class org.apache.tools.ant.types.DataType

      `checked, ref`

    - ### Fields inherited from class org.apache.tools.ant.ProjectComponent

      `description, location, project`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SizeSelector()` Creates a new `SizeSelector` instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `isSelected(java.io.File basedir, java.lang.String filename, java.io.File file)` The heart of the matter.
    `void` | `setParameters(Parameter[] parameters)` When using this as a custom selector, this method will be called.
    `void` | `setUnits(SizeSelector.ByteUnits units)` Sets the units to use for the comparison.
    `void` | `setValue(long size)` A size selector needs to know what size to base its selecting on.
    `void` | `setWhen(SizeSelector.SizeComparisons when)` This specifies when the file should be selected, whether it be when the file matches a particular size, when it is smaller, or whether it is larger.
    `java.lang.String` | `toString()` Returns a `String` object representing the specified SizeSelector.
    `void` | `verifySettings()` Checks to make sure all settings are kosher.

    - ### Methods inherited from class org.apache.tools.ant.types.selectors.BaseExtendSelector

      `getParameters`

    - ### Methods inherited from class org.apache.tools.ant.types.selectors.BaseSelector

      `getError, setError, setError, validate`

    - ### Methods inherited from class org.apache.tools.ant.types.DataType

      `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes`

    - ### Methods inherited from class org.apache.tools.ant.ProjectComponent

      `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### SIZE_KEY

          public static final java.lang.String SIZE_KEY

      Used for parameterized custom selector
      See Also:
        Constant Field Values

    - #### UNITS_KEY

          public static final java.lang.String UNITS_KEY

      Used for parameterized custom selector
      See Also:
        Constant Field Values

    - #### WHEN_KEY

          public static final java.lang.String WHEN_KEY

      Used for parameterized custom selector
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### SizeSelector

          public SizeSelector()

      Creates a new `SizeSelector` instance.

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Returns a `String` object representing the specified SizeSelector. This is "{sizeselector value: " + <"compare", "less", "more", "equal"> + "}".
      Overrides:
        `toString` in class `DataType`
      Returns:
        a string describing this object

    - #### setValue

          public void setValue(long size)

      A size selector needs to know what size to base its selecting on. This will be further modified by the multiplier to get an actual size limit.
      Parameters:
        `size` - the size to select against expressed in units.

    - #### setUnits

          public void setUnits(SizeSelector.ByteUnits units)

      Sets the units to use for the comparison. This is a little complicated because common usage has created standards that play havoc with capitalization rules. Thus, some people will use "K" for indicating 1000's, when the SI standard calls for "k". Others have tried to introduce "K" as a multiple of 1024, but that falls down when you reach "M", since "m" is already defined as 0.001.

      To get around this complexity, a number of standards bodies have proposed the 2^10 standard, and at least one has adopted it. But we are still left with a populace that isn't clear on how capitalization should work.

      We therefore ignore capitalization as much as possible. Completely mixed case is not possible, but all upper and lower forms are accepted for all long and short forms. Since we have no need to work with the 0.001 case, this practice works here.

      This function translates all the long and short forms that a unit prefix can occur in and translates them into a single multiplier.

      Parameters:
        `units` - The units to compare the size to, using an EnumeratedAttribute.

    - #### setWhen

          public void setWhen(SizeSelector.SizeComparisons when)

      This specifies when the file should be selected, whether it be when the file matches a particular size, when it is smaller, or whether it is larger.
      Parameters:
        `when` - The comparison to perform, an EnumeratedAttribute.

    - #### setParameters

          public void setParameters(Parameter[] parameters)

      When using this as a custom selector, this method will be called. It translates each parameter into the appropriate setXXX() call.
      Specified by:
        `setParameters` in interface `Parameterizable`
      Overrides:
        `setParameters` in class `BaseExtendSelector`
      Parameters:
        `parameters` - the complete set of parameters for this selector.

    - #### verifySettings

          public void verifySettings()

      Checks to make sure all settings are kosher. In this case, it means that the size attribute has been set (to a positive value), that the multiplier has a valid setting, and that the size limit is valid. Since the latter is a calculated value, this can only fail due to a programming error.

      If a problem is detected, the setError() method is called.

      Overrides:
        `verifySettings` in class `BaseSelector`

    - #### isSelected

          public boolean isSelected(java.io.File basedir,
                                    java.lang.String filename,
                                    java.io.File file)

      The heart of the matter. This is where the selector gets to decide on the inclusion of a file in a particular fileset.
      Specified by:
        `isSelected` in interface `FileSelector`
      Specified by:
        `isSelected` in class `BaseExtendSelector`
      Parameters:
        `basedir` - A java.io.File object for the base directory.
        `filename` - The name of the file to check.
        `file` - A File object for this filename.
      Returns:
        whether the file should be selected or not.